import { declare } from '@babel/helper-plugin-utils';
import { readFileSync } from 'fs';
import { parse } from 'fast-xml-parser';
import pluginTransformTypeScript from '@babel/plugin-transform-typescript';
import presetTypeScript from '@babel/preset-typescript';

var index = declare((api, options = {}) => {
  api.assertVersion(7);
  return {
    "presets": [[presetTypeScript, options]],
    "overrides": [{
      "test": filePath => {
        if (/\.vue$/.test(filePath)) {
          const json = parse(readFileSync(filePath, {
            encoding: "utf8"
          }), {
            ignoreAttributes: false
          });

          if (json.script && typeof json.script === "object" && typeof json.script["@_lang"] === "string" && json.script["@_lang"].toLowerCase() === "ts") {
            return true;
          }
        }

        return false;
      },
      "plugins": [[pluginTransformTypeScript, options]]
    }]
  };
});

export default index;
